summaryrefslogtreecommitdiff
path: root/scripts/git-submodule.sh
diff options
context:
space:
mode:
authorDaniel P. Berrange <berrange@redhat.com>2017-10-20 15:02:43 +0100
committerDaniel P. Berrange <berrange@redhat.com>2017-11-06 11:03:45 +0000
commitcc84d63a42e31c2afa884fc78610a65ab8ecc06a (patch)
treea3227666385f67cc52edf21670cb05437216b1ad /scripts/git-submodule.sh
parentec7a8bf0b8f7dc7288fe8745464ee8217528cc6c (diff)
downloadqemu-cc84d63a42e31c2afa884fc78610a65ab8ecc06a.tar.gz
build: allow setting a custom GIT binary for transparent proxying
Some users can't run a bare 'git' command, due to need for a transparent proxying solution such as 'tsocks'. This adds an argument to configure to let users specify such a thing: ./configure --with-git="tsocks git" The submodule script is also updated to give the user a hint about using this flag, if we fail to checkout modules. Tested-by: Philippe Mathieu-Daudé <f4bug@amsat.org> Reviewed-by: Eric Blake <eblake@redhat.com> Signed-off-by: Daniel P. Berrange <berrange@redhat.com>
Diffstat (limited to 'scripts/git-submodule.sh')
-rwxr-xr-xscripts/git-submodule.sh29
1 files changed, 24 insertions, 5 deletions
diff --git a/scripts/git-submodule.sh b/scripts/git-submodule.sh
index 08932a35f0..039f782d81 100755
--- a/scripts/git-submodule.sh
+++ b/scripts/git-submodule.sh
@@ -3,14 +3,27 @@
# This code is licensed under the GPL version 2 or later. See
# the COPYING file in the top-level directory.
-set -e
-
substat=".git-submodule-status"
command=$1
shift
modules="$@"
+test -z "$GIT" && GIT=git
+
+error() {
+ echo "$0: $*"
+ echo
+ echo "Unable to automatically checkout GIT submodules '$modules'."
+ echo "If you require use of an alternative GIT binary (for example to"
+ echo "enable use of a transparent proxy), then please specify it by"
+ echo "running configure by with the '--with-git' argument. e.g."
+ echo
+ echo " $ ./configure --with-git='tsocks git'"
+ echo
+ exit 1
+}
+
if test -z "$modules"
then
test -e $substat || touch $substat
@@ -27,12 +40,18 @@ case "$command" in
status)
test -f "$substat" || exit 1
trap "rm -f ${substat}.tmp" EXIT
- git submodule status $modules > "${substat}.tmp"
+ $GIT submodule status $modules > "${substat}.tmp"
+ test $? -ne 0 && error "failed to query git submodule status"
diff "${substat}" "${substat}.tmp" >/dev/null
exit $?
;;
update)
- git submodule update --init $modules 1>/dev/null
- git submodule status $modules > "${substat}"
+ $GIT submodule update --init $modules 1>/dev/null
+ test $? -ne 0 && error "failed to update modules"
+
+ $GIT submodule status $modules > "${substat}"
+ test $? -ne 0 && error "failed to save git submodule status" >&2
;;
esac
+
+exit 0